import sympy

def iterative_computation(P,E,N):
    v = sympy.zeros(P.rows,1)
    pe = elementwise_multiplication(P,E) * sympy.ones(P.rows,1)
    i = N
    n = 0
    z = pe
    # computing sum_k=1^n P^{k-1}
    while i != 0:
        if i % 2 == 1:
            v = z + ((P**(2**n)) * v)
        z = z + ((P**(2**n)) * z)      
        i = i // 2
        n = n+1
    return v[0,0] # (P[0:4,0].T*E[0:4,0]) + (P[0:4,0].T * v)

def elementwise_multiplication(matrix1,matrix2):
    if matrix1.rows != matrix2.rows or matrix1.cols != matrix2.cols:
        raise("Can only multiply matrices of equal size element-wise!")
    result = sympy.zeros(matrix1.rows,matrix1.cols)
    for row in xrange(0,matrix1.rows):
        for col in xrange(0,matrix1.cols):
            result[row,col] = matrix1[row,col] * matrix2[row,col]
    return result